<template>
  <v-app>
    <v-toolbar fixed app dark color="indigo darken-1" v-if="isAuthenticated">
      <img src="./img/logo.png" height="24px">
      <v-toolbar-title v-text="title" class="hidden-xs-only"></v-toolbar-title>
      <v-spacer></v-spacer>
      <v-text-field flat solo-inverted prepend-icon="search" label="Search posts" class="hidden-sm-and-down" v-model="searchPost"></v-text-field>
      <v-btn flat class="hidden-sm-and-down" @click="filterModal = true">
        <v-icon left>filter_list</v-icon>
        filter
      </v-btn>
      <v-spacer></v-spacer>
      <v-btn outline small :disabled="auth.user.displayName == null" @click="newPostDialog = true">
        <v-icon left size="18px" class="hidden-xs-only">comment</v-icon>
        new post
      </v-btn>
      <v-menu min-width="200px" bottom offset-y>
        <v-avatar size="32px" class="ml-3 mr-3" slot="activator">
          <img :src="auth.user.photoURL" v-if="auth.user.photoURL != null">
          <v-icon size="32px" v-else>account_circle</v-icon>
        </v-avatar>
        <v-list dense>
          <v-list-tile @click="showProfileScreen()" :disabled="showProfile">
            <v-list-tile-avatar><v-icon>account_circle</v-icon></v-list-tile-avatar>
            <v-list-tile-title>Profile</v-list-tile-title>
          </v-list-tile>
          <v-list-tile @click="showGalleryScreen()" :disabled="showPictures || auth.user.displayName == null">
            <v-list-tile-avatar><v-icon>camera_alt</v-icon></v-list-tile-avatar>
            <v-list-tile-title>Photos</v-list-tile-title>
          </v-list-tile>
          <v-list-tile @click="followingDialog = true" :disabled="auth.user.displayName == null">
            <v-list-tile-avatar><v-icon>supervised_user_circle</v-icon></v-list-tile-avatar>
            <v-list-tile-title>Following</v-list-tile-title>
          </v-list-tile>
          <v-list-tile @click="signOut()">
            <v-list-tile-avatar><v-icon>exit_to_app</v-icon></v-list-tile-avatar>
            <v-list-tile-title>Sign out</v-list-tile-title>
          </v-list-tile>
        </v-list>
      </v-menu>
    </v-toolbar>
    <v-content v-if="isAuthenticated">
      <v-container>
        <v-card v-if="showProfile">
          <v-flex xs6 class="pa-3 ml-2">
            <v-layout align-center row wrap class="pa-0 ma-0">
              <v-flex xs4 sm2 md1 class="d-inline-flex">
                <v-btn icon class="mx-0" @click="showProfile = false, targetProfile != '' ? showTargetProfile = true : ''" style="max-width: 38px;min-width:38px" v-if="auth.user.displayName != null">
                  <v-icon color="grey darken-2">chevron_left</v-icon>
                </v-btn>
              </v-flex>
              <v-flex xs8 sm10 md11 class="d-inline-flex">
                <h3 class="mr-3" :class="auth.user.displayName == null ? 'pa-3' : ''">
                  Welcome {{ displayName() }}
                </h3>
              </v-flex>
            </v-layout>
          </v-flex>
          <v-divider></v-divider>
          <v-card-text class="pa-0">
            <v-layout row wrap>
              <v-flex xs12 class="grey lighten-4 pa-4" v-if="auth.user.displayName == null">
                <span>It's seems that's your first login. Let's update all your profile information.</span>
              </v-flex>
              <v-flex xs12 sm4 md3 lg2 class="pa-0">
                <v-flex text-xs-center align-center class="py-3 px-2">
                  <v-avatar :size="128" color="grey lighten-4" class="d-inline-block ma-4">
                    <img src="./img/blank-avatar.png" v-if="auth.user.photoURL == null">
                    <img :src="profilePicture" v-else-if="profilePicture != null">
                    <img :src="auth.user.photoURL" v-else>
                  </v-avatar>
                  <v-btn dark small color="indigo" :loading="loader" class="d-inline-block mt-3" @click="$refs.upload.click()">
                    <v-icon left size="16px">cloud_upload</v-icon>
                    {{auth.user.photoURL == null ? 'Upload picture' : 'Change picture'}}
                  </v-btn>
                  <input type="file" style="display:none;" ref="upload" accept="image/*" @change="profilePictureChange">
                </v-flex>
              </v-flex>
              <v-flex xs12 sm8 md9 lg10 class="pa-4" style="border-left:1px solid rgba(0,0,0,.12)">
                <v-flex xs12 class="mt-2">
                  <h2>Profile information</h2>
                </v-flex>
                <v-divider class="mb-4"></v-divider>
                <v-container grid-list-lg>
                  <v-form v-model="updateProfileForm">
                    <v-layout wrap row>
                      <v-flex xs12 sm6>
                        <v-text-field required label="Fullname" prepend-icon="face" color="indigo" :rules="basicRules" v-model="profileInfo.fullname"></v-text-field>
                        <v-select autocomplete required no-data-text="No country found." label="Country" prepend-icon="place" color="indigo" :items="countries" :rules="basicRules" v-model="profileInfo.country"></v-select>
                      </v-flex>
                      <v-flex xs12 sm6>
                        <v-text-field label="Occupation" prepend-icon="work" :rules="basicRules" color="indigo" v-model="profileInfo.occupation" required></v-text-field>
                        <v-menu ref="menu" :close-on-content-click="false" v-model="birthMenu" :nudge-right="40" lazy transition="scale-transition" color="indigo" full-width min-width="290px">
                          <v-text-field readonly required slot="activator" v-model="profileInfo.birthday" label="Birthday date" prepend-icon="event" color="indigo" :rules="basicRules" ></v-text-field>
                          <v-date-picker ref="picker" v-model="profileInfo.birthday" :max="new Date().toISOString().substr(0, 10)" min="1950-01-01" @change="save"></v-date-picker>
                        </v-menu>
                      </v-flex>
                      <v-flex xs12>
                        <v-text-field box textarea required color="indigo" label="About me" :rules="aboutMeRules" v-model="profileInfo.about"></v-text-field>
                      </v-flex>
                    </v-layout>
                  </v-form>
                </v-container>
              </v-flex>
            </v-layout>
          </v-card-text>
          <v-divider></v-divider>
          <v-card-actions class="pa-4">
            <v-btn flat color="grey darken-2" @click="showProfile = false, targetProfile != '' ? showTargetProfile = true : ''" v-if="auth.user.displayName != null">close</v-btn>
            <v-spacer></v-spacer>
            <v-btn :dark="updateProfileForm && !profileLoader" color="indigo" :disabled="!updateProfileForm || profileLoader" :loading="profileLoader" @click="updateProfile()">update profile</v-btn>
          </v-card-actions>
        </v-card>
        <v-card v-if="showPictures">
          <v-layout row wrap class="py-3 px-4">
            <v-flex xs6>
              <v-layout align-center row wrap class="pa-0 ma-0">
                <v-flex xs4 sm2 md1 class="d-inline-flex">
                  <v-btn icon class="mx-0" @click="showPictures = false, targetProfile != '' ? showTargetProfile = true : ''" style="max-width: 38px;min-width:38px">
                    <v-icon color="grey darken-2">chevron_left</v-icon>
                  </v-btn>
                </v-flex>
                <v-flex xs8 sm10 md11 class="d-inline-flex">
                  <h3 class="mr-3">
                    Photo Gallery
                  </h3>
                </v-flex>
              </v-layout>
            </v-flex>
            <v-flex xs6 text-xs-right>
              <v-btn :dark="!pictureLoader" color="indigo" :disabled="pictureLoader" :loading="pictureLoader" @click="$refs.photos.click()">
                <v-icon left size="16px">camera_alt</v-icon>
                add photos
              </v-btn>
              <input multiple type="file" style="display:none;" ref="photos" accept="image/*" @change="addPhotos($event)">
            </v-flex>
          </v-layout>
          <v-divider></v-divider>
          <v-card-text class="grey lighten-3" style="height: calc(100vh - 176px); overflow:auto">
            <v-container fluid grid-list-md style="max-width: 1200px">
              <v-layout row wrap v-if="userPictures != ''">
                <v-flex v-for="i, index, key in userPictures" :key="index" xs12 sm6 md4 lg3>
                  <v-card hover v-if="index != '.key' && i != null" @click.native.stop="zoom(i.url)">
                    <v-card-media :src="i.url" height="300px">
                      <span class="pa-3 grey--text text--lighten-4" style="position:absolute; bottom: 0px; background: rgba(0,0,0,.12); width: 100%;" v-if="i.description != ''">{{i.description}}</span>
                    </v-card-media>
                    <v-card-actions class="white">
                      <v-btn icon @click.stop="photoDescription = index" v-if="photoDescription != index">
                        <v-icon color="grey darken-2">keyboard_arrow_down</v-icon>
                      </v-btn>
                      <v-btn icon @click.stop="photoDescription = -1" v-else>
                        <v-icon color="grey darken-2">keyboard_arrow_up</v-icon>
                      </v-btn>
                      <v-spacer></v-spacer>
                      <v-btn icon @click.stop="deletePhoto(i['.key'])">
                        <v-icon color="grey darken-2">delete</v-icon>
                      </v-btn>
                    </v-card-actions>
                    <v-slide-y-transition>
                      <v-card-text class="pt-0 pb-3" v-show="index == photoDescription">
                        <v-text-field textarea counter="35" color="indigo" :rules="photoRules" label="Photo description" v-model="i.description" @click.stop=""></v-text-field>
                        <v-btn block outline color="indigo" class="mt-3" :disabled="i.description.length > 35" @click.stop="updatePhoto(i)">update description</v-btn>
                      </v-card-text>
                    </v-slide-y-transition>
                  </v-card>
                </v-flex>
              </v-layout>
              <v-layout row wrap justify-center v-else>
                <v-flex xs12>
                  <v-card flat class="text-xs-center grey lighten-3" style="height:calc(100vh - 270px); justify-content:center; align-items:center; display: flex">
                    <v-card-text>
                      <v-icon class="my-5" color="grey lighten-1" size="120px">insert_photo</v-icon><br>
                      <span class="grey--text">Add some photos to your album :)</span>
                    </v-card-text>
                  </v-card>
                </v-flex>
              </v-layout>
            </v-container>
          </v-card-text>
        </v-card>
        <app-timeline :posts.sync="filteredPosts" :shadowPosts.sync="shadowPosts" :uid.sync="auth.user.uid" :profile.sync="profileInfo" v-show="!showProfile && !showPictures && auth.user.displayName != null && targetProfile == ''" v-on:updateProfile="profileInfo = $event" v-on:checkProfile="targetProfile = $event, showTargetProfile = true"></app-timeline>
        <v-flex class="text-xs-center my-5" v-if="(posts != null && posts.length > 0 || shadowPosts != null && shadowPosts.length > 0) && auth.user.displayName != null && !showProfile && !showPictures && targetProfile == ''">
          <v-btn dark color="indigo" :loading="postLoader" @click.stop="loadMore()">Load more posts</v-btn>
        </v-flex>
        <app-profile :profile="targetProfile" v-on:zoomPhoto="zoom($event)" v-on:hideProfile="targetProfile = $event, showTargetProfile = false" v-show="showTargetProfile"></app-profile>
      </v-container>
    </v-content>
    <v-dialog persistent max-width="500px" :value="!isAuthenticated">
      <v-toolbar dark color="indigo darken-1">
        <v-toolbar-title>{{createAccount ? 'Create an Account' : 'Welcome to Ilegra Social Network'}}</v-toolbar-title>
      </v-toolbar>
      <v-card class="grey lighten-4">
        <v-card-text class="pa-4">
          <v-flex v-if="!createAccount">
            <v-alert outline :value="auth.hasErrors" type="error">
              {{ this.auth.message }}
            </v-alert>
            <v-alert outline :value="auth.success" type="success">
              {{ this.auth.message }}
            </v-alert>
            <v-flex xs12 class="px-4 py-2">
              <v-subheader class="pl-0">Login information</v-subheader>
              <v-divider class="mb-4"></v-divider>
              <v-flex xs12 class="text-xs-right">
                <v-form v-model="validLogin">
                  <v-text-field solo flat class="mb-3" color="indigo" placeholder="E-mail" :rules="emailRules" v-model="loginInformation.email"></v-text-field>
                  <v-text-field solo flat placeholder="Password" color="indigo" :append-icon="!passwordShow ? 'visibility' : 'visibility_off'" :append-icon-cb="() => (passwordShow = !passwordShow)" :type="!passwordShow ? 'password' : 'text'" :rules="passwordRules" v-model="loginInformation.password"></v-text-field>
                </v-form>
                <v-spacer></v-spacer>
                <v-btn small flat class="ma-0 mt-3" color="grey darken-1" style="font-size:12px">
                  forgot your password ?
                </v-btn>
              </v-flex>
            </v-flex>
          </v-flex>
          <v-flex v-else>
            <v-alert outline :value="auth.hasErrors" type="error">
              {{ this.auth.message }}
            </v-alert>
            <v-flex xs12 class="px-4 pt-4">
              <v-form class="accountForm" v-model="validAccountCreation">
                <v-text-field required label="E-mail" color="indigo" :rules="emailRules" v-model="newUser.email"></v-text-field>
                <v-text-field required counter label="Password" max="25" color="indigo" :rules="passwordRules" :append-icon="!passwordShow ? 'visibility' : 'visibility_off'" :append-icon-cb="() => (passwordShow = !passwordShow)" :type="!passwordShow ? 'password' : 'text'" v-model="newUser.password"></v-text-field>
                <v-text-field required label="Repeat password" color="indigo" :rules="passwordRepeatRules" :append-icon="!passwordShow ? 'visibility' : 'visibility_off'" :append-icon-cb="() => (passwordShow = !passwordShow)" :type="!passwordShow ? 'password' : 'text'" v-model="newUser.repeatPassword"></v-text-field>
                <v-checkbox label="Agree to the Terms of Service and Privacy Policy" color="indigo" class="mt-3" :rules="[v => !!v || 'You must agree to continue!']" v-model="newUser.confirmation"></v-checkbox>
              </v-form>
            </v-flex>
          </v-flex>
        </v-card-text>
        <v-card-actions class="pa-4">
          <v-btn dark flat color="indigo" v-if="!createAccount" @click="createAccount = true">create account</v-btn>
          <v-btn dark flat color="grey darken-1" v-else @click="createAccount = false, auth.message = '', auth.hasErrors = false">back</v-btn>
          <v-spacer></v-spacer>
          <v-btn :dark="validLogin && !loader" color="indigo" v-if="!createAccount" :disabled="!validLogin || loader" :loading="loader" @click="signIn()">login</v-btn>
          <v-btn :dark="validAccountCreation && !loader" color="indigo" :disabled="!validAccountCreation || loader" v-if="createAccount" :loading="loader" @click="registerAccount()">register</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-dialog scrollable content-class="photoZoom" v-model="zoomPhotoDialog">
      <v-card class="pa-0 ma-0">
        <v-toolbar dark class="transparent" absolute flat>
          <v-spacer></v-spacer>
          <v-btn icon small class="mx-3" color="white" @click="zoomPhotoDialog = false">
            <v-icon color="red" size="16px">close</v-icon>
          </v-btn>
        </v-toolbar>
        <img :src="zoomedPhoto" height="100%" width="100%">
      </v-card>
    </v-dialog>
    <v-dialog scrollable persistent max-width="1200px" v-model="newPostDialog">
      <v-card v-if="newPostDialog">
        <v-card-text class="pa-0">
          <v-layout row wrap>
            <v-flex xs12 class="pa-4">
              <h2 class="indigo--text">Create new post</h2>
            </v-flex>
            <v-flex xs12>
              <v-divider></v-divider>
            </v-flex>
            <v-flex xs12 sm5 md4 text-xs-center class="grey lighten-4 pa-4">
              <h3>Post picture</h3>
              <v-layout row wrap align-center justify-center>
                <v-flex>
                  <v-card-media contain class="ma-4" :src="postImagePreview" height="200px" v-if="postImagePreview != ''"></v-card-media>
                  <img src="./img/placeholder.png" class="ma-4" width="60%" v-else></img>
                  <input multiple type="file" style="display:none;" ref="postPhoto" accept="image/*" @change="postPhoto">
                  <v-btn dark color="indigo" @click="$refs.postPhoto.click()">
                    <v-icon left>camera_alt</v-icon>
                    {{postImagePreview != '' ? 'change photo' : 'add photo'}}
                  </v-btn>
                  <v-btn dark color="error" @click="postImagePreview = ''" v-if="postImagePreview != ''">
                    <v-icon left>delete_outline</v-icon>
                    remove photo
                  </v-btn>
                </v-flex>
              </v-layout>
            </v-flex>
            <v-flex xs12 sm7 md8 class="pa-4">
              <h3>Post information</h3>
              <v-form class="mt-3 px-4" v-model="validPost">
                <v-text-field label="Title" counter="50" prepend-icon="title" color="indigo" :rules="postTitleRule" v-model="post.title"></v-text-field>
                <v-text-field label="Brief description" counter="80" prepend-icon="notes" color="indigo" :rules="postSubRule" v-model="post.subTitle"></v-text-field>
                <v-text-field textarea label="Full description" counter="256" color="indigo" :rules="postDescriptionRule" v-model="post.description"></v-text-field>
              </v-form>
            </v-flex>
          </v-layout>
        </v-card-text>
        <v-divider></v-divider>
        <v-card-actions class="pa-4">
          <v-btn flat color="grey darken-2" @click="newPostDialog = false">close</v-btn>
          <v-spacer></v-spacer>
          <v-btn :dark="validPost && !postLoader" color="indigo" :disabled="!validPost || postLoader" :loading="postLoader" @click="sendPost()">post</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-dialog scrollable persistent max-width="600px" v-model="followingDialog">
      <v-card>
        <v-card-text class="pa-0 ma-0">
          <v-flex xs12 class="pa-4">
            <h2 class="indigo--text">Following</h2>
          </v-flex>
          <v-flex xs12>
            <v-divider></v-divider>
          </v-flex>
          <v-flex xs12>
            <v-list v-if="profileInfo.following != ''">
              <v-list-tile v-for="i, index in profileInfo.following" :key="index" avatar @click="">
                <v-list-tile-avatar>
                  <img :src="profilesPic[i] != '' && profilesPic[i] != null ? profilesPic[i] : require('./img/blank-avatar.png')">
                </v-list-tile-avatar>
                <v-list-tile-content>
                  <v-list-tile-title>{{profilesName[i]}}</v-list-tile-title>
                </v-list-tile-content>
                <v-list-tile-action>
                  <v-btn flat color="error" @click.stop="unfollow(i)">
                    unfollow
                  </v-btn>
                </v-list-tile-action>
              </v-list-tile>
            </v-list>
            <v-layout row wrap justify-center v-else>
              <v-flex xs12>
                <v-card flat class="text-xs-center grey lighten-4" style="height:300px; justify-content:center; align-items:center; display: flex">
                  <v-card-text>
                    <v-icon class="my-3" color="grey lighten-1" size="64px">sentiment_dissatisfied</v-icon><br>
                    <span class="grey--text">You aren't following anyone yet</span>
                  </v-card-text>
                </v-card>
              </v-flex>
            </v-layout>
          </v-flex>
        </v-card-text>
        <v-divider></v-divider>
        <v-card-actions class="pa-3">
          <v-btn block flat color="grey darken-2" @click="followingDialog = false">close</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <v-dialog scrollable persistent max-width="400px" v-model="filterModal">
      <v-card>
        <v-card-text class="pa-0 ma-0">
          <v-flex xs12 class="pa-4">
            <h2 class="indigo--text">Posts filter</h2>
          </v-flex>
          <v-flex xs12>
            <v-divider></v-divider>
          </v-flex>
          <v-flex xs12 class="pa-4">
            <v-radio-group v-model="postFilter">
              <v-radio label="All posts" color="indigo" :value="1"></v-radio>
              <v-radio label="My posts only" color="indigo" :value="3"></v-radio>
              <v-radio label="Posts that you liked" color="indigo" :value="4"></v-radio>
              <v-radio label="Followers posts only" color="indigo" :value="2"></v-radio>
            </v-radio-group>
          </v-flex>
        </v-card-text>
        <v-divider></v-divider>
        <v-card-actions class="pa-3">
          <v-btn block flat color="grey darken-2" @click="filterModal = false">close</v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </v-app>
</template>

<script>
  import {db} from './firebase';
  import {auth} from './firebase';
  import {storage} from './firebase';
  import timeline from './timeline';
  import profile from './profile';

  export default {
    data () {
      return {
        auth: {
          user: ''
        },
        loader: false,
        title: 'Ilegra Social Network',
        validLogin: false,
        validAccountCreation: false,
        passwordShow: false,
        createAccount: false,
        loginInformation: {
          email: '',
          password: ''
        },
        newUser: {
          email: '',
          password: '',
          repeatPassword: '',
          confirmation: ''
        },
        basicRules: [
          v => !!v || 'This field is required',
          v => v.length >= 3 || 'At least 3 characters'
        ],
        aboutMeRules: [
          v => !!v || 'Please tell us more about yourself :)',
          v => v.length >= 10 && v.length <= 256 || "Please tell more about yourself. (Min. 10 chars)"
        ],
        emailRules: [
          v => !!v || 'E-mail is required',
          v => /^\w+([.-]?\w+)*@\w+([.-]?\w+)*(\.\w{2,3})+$/.test(v) || 'E-mail must be valid'
        ],
        passwordRules: [
          v => !!v || 'Password is required',
          v => v.length >= 6 || 'At least 6 characters',
          v => v.length <= 25 || 'Password is too big, max. 25 characters'
        ],
        passwordRepeatRules: [
          v => !!v || 'Password is required',
          v => this.newUser.password == v || "Passwords don't match"
        ],
        photoRules: [
            v => v.length <= 35 || "Max. 35 characters"
        ],
        birthMenu: false,
        profilePicture: null,
        profileLoader: false,
        profileInfo: {
          fullname: '',
          occupation: '',
          country: '',
          birthday: '',
          about: '',
          following: ''
        },
        updateProfileForm: false,
        showProfile: false,
        showPictures: false,
        pictureLoader: false,
        userPictures: [],
        photoDescription: -1,
        zoomPhotoDialog: false,
        zoomedPhoto: '',
        newPostDialog: false,
        validPost: false,
        post: {
          title: '',
          subTitle: '',
          description: '',
          photo: '',
          author: '',
          date: '',
          likes: ''
        },
        postImagePreview: '',
        tempPhoto: '',
        postLoader: false,
        postTitleRule: [
          v => !!v || 'This field is required',
          v => v.length >= 3 || 'At least 3 characters',
          v => v.length <= 50 || 'Max. 50 characters'
        ],
        postSubRule: [
          v => !!v || 'This field is required',
          v => v.length >= 3 || 'At least 3 characters',
          v => v.length <= 80 || 'Max. 80 characters'
        ],
        postDescriptionRule: [
          v => !!v || 'This field is required',
          v => v.length >= 3 || 'At least 3 characters',
          v => v.length <= 256 || 'Max. 256 characters'
        ],
        searchPost: '',
        lastKey: 4,
        shadowPosts: '',
        followingDialog: false,
        profilesPic: [],
        profilesName: [],
        filterModal: false,
        postFilter: 1,
        targetProfile: '',
        showTargetProfile: false,
        countries: [
          'Afghanistan', 'Åland Islands', 'Albania', 'Algeria', 'American Samoa', 'Andorra', 'Angola', 'Anguilla', 'Antigua and Barbuda', 'Argentina', 'Armenia', 'Aruba', 'Australia', 'Austria', 'Azerbaijan', 'Bangladesh', 'Barbados', 'Bahamas', 'Bahrain', 'Belarus', 'Belgium', 'Belize', 'Benin', 'Bermuda', 'Bhutan', 'Bolivia', 'Bosnia and Herzegovina', 'Botswana', 'Brazil', 'British Indian Ocean Territory', 'British Virgin Islands', 'Brunei Darussalam', 'Bulgaria', 'Burkina Faso', 'Burma', 'Burundi', 'Cambodia', 'Cameroon', 'Canada', 'Cape Verde', 'Cayman Islands', 'Central African Republic', 'Chad', 'Chile', 'China', 'Christmas Island', 'Cocos (Keeling) Islands', 'Colombia', 'Comoros', 'Congo-Brazzaville', 'Congo-Kinshasa', 'Cook Islands', 'Costa Rica', '$_[', 'Croatia', 'Curaçao', 'Cyprus', 'Czech Republic', 'Denmark', 'Djibouti', 'Dominica', 'Dominican Republic', 'East Timor', 'Ecuador', 'El Salvador', 'Egypt', 'Equatorial Guinea', 'Eritrea', 'Estonia', 'Ethiopia', 'Falkland Islands', 'Faroe Islands', 'Federated States of Micronesia', 'Fiji', 'Finland', 'France', 'French Guiana', 'French Polynesia', 'French Southern Lands', 'Gabon', 'Gambia', 'Georgia', 'Germany', 'Ghana', 'Gibraltar', 'Greece', 'Greenland', 'Grenada', 'Guadeloupe', 'Guam', 'Guatemala', 'Guernsey', 'Guinea', 'Guinea-Bissau', 'Guyana', 'Haiti', 'Heard and McDonald Islands', 'Honduras', 'Hong Kong', 'Hungary', 'Iceland', 'India', 'Indonesia', 'Iraq', 'Ireland', 'Isle of Man', 'Israel', 'Italy', 'Jamaica', 'Japan', 'Jersey', 'Jordan', 'Kazakhstan', 'Kenya', 'Kiribati', 'Kuwait', 'Kyrgyzstan', 'Laos', 'Latvia', 'Lebanon', 'Lesotho', 'Liberia', 'Libya', 'Liechtenstein', 'Lithuania', 'Luxembourg', 'Macau', 'Macedonia', 'Madagascar', 'Malawi', 'Malaysia', 'Maldives', 'Mali', 'Malta', 'Marshall Islands', 'Martinique', 'Mauritania', 'Mauritius', 'Mayotte', 'Mexico', 'Moldova', 'Monaco', 'Mongolia', 'Montenegro', 'Montserrat', 'Morocco', 'Mozambique', 'Namibia', 'Nauru', 'Nepal', 'Netherlands', 'New Caledonia', 'New Zealand', 'Nicaragua', 'Niger', 'Nigeria', 'Niue', 'Norfolk Island', 'Northern Mariana Islands', 'Norway', 'Oman', 'Pakistan', 'Palau', 'Panama', 'Papua New Guinea', 'Paraguay', 'Peru', 'Philippines', 'Pitcairn Islands', 'Poland', 'Portugal', 'Puerto Rico', 'Qatar', 'Réunion', 'Romania', 'Russia', 'Rwanda', 'Saint Barthélemy', 'Saint Helena', 'Saint Kitts and Nevis', 'Saint Lucia', 'Saint Martin', 'Saint Pierre and Miquelon', 'Saint Vincent', 'Samoa', 'San Marino', 'São Tomé and Príncipe', 'Saudi Arabia', 'Senegal', 'Serbia', 'Seychelles', 'Sierra Leone', 'Singapore', 'Sint Maarten', 'Slovakia', 'Slovenia', 'Solomon Islands', 'Somalia', 'South Africa', 'South Georgia', 'South Korea', 'Spain', 'Sri Lanka', 'Sudan', 'Suriname', 'Svalbard and Jan Mayen', 'Sweden', 'Swaziland', 'Switzerland', 'Syria', 'Taiwan', 'Tajikistan', 'Tanzania', 'Thailand', 'Togo', 'Tokelau', 'Tonga', 'Trinidad and Tobago', 'Tunisia', 'Turkey', 'Turkmenistan', 'Turks and Caicos Islands', 'Tuvalu', 'Uganda', 'Ukraine', 'United Arab Emirates', 'United Kingdom', 'United States', 'Uruguay', 'Uzbekistan', 'Vanuatu', 'Vatican City', 'Vietnam', 'Venezuela', 'Wallis and Futuna', 'Western Sahara', 'Yemen', 'Zambia', 'Zimbabwe'
        ]
      }
    },
    firebase: {
      posts: db.ref('posts').orderByChild("date").limitToFirst(4)
    },
    components: {
      'appTimeline': timeline,
      'appProfile': profile
    },
    watch: {
      menu (val) {
        val && this.$nextTick(() => (this.$refs.picker.activePicker = 'YEAR'))
      },
      profileInfo: function(info) {
        var vm = this;
        info = info.following;
        if(Array.isArray(info)) {
          info.forEach((i) => {
            db.ref('users').child(i).once('value').then((snapshot) => {
              if(snapshot.val() != null) {
                if(snapshot.val().picture != '' && snapshot.val().picture != null) {
                  vm.$set(vm.profilesPic, i, snapshot.val().picture)
                }
                if(snapshot.val().fullname != '' && snapshot.val().fullname != null) {
                  vm.$set(vm.profilesName, i, snapshot.val().fullname)
                }
              }
            });
          });
        }
      },
      targetProfile: function(tprofile) {
        if(tprofile != '') {
          this.showProfile = false;
          this.showPictures = false;
        }
      }
    },
    computed: {
      isAuthenticated: function () {
        var vm = this;
        auth.onAuthStateChanged(function (user) {
          if(user) {
            this.auth.user = user;
            if(this.auth.user.displayName == null) {
              this.showProfile = true;
            }
            this.$bindAsArray('posts', db.ref('posts').orderByChild("date").limitToFirst(vm.lastKey));
            db.ref('/users/'+user.uid).once('value').then(function(snapshot) {
              if(snapshot.val() != undefined && snapshot.val() != null) {
                vm.profileInfo = snapshot.val();
              } else {
                vm.profileInfo = {
                  fullname: '',
                  occupation: '',
                  country: '',
                  birthday: '',
                  about: '',
                  following: ''
                }
              }
            });
          } else {
            this.auth.user = null;
          }
        }.bind(this));
        return (this.auth.user !== null);
      },
      filteredPosts: function () {
        var vm = this;
        var temp_post = vm.posts;
        if(this.postFilter == 2) {
          temp_post = temp_post.filter((post) => {
            return vm.profileInfo.following.includes(post.author);
          });
        } else if(this.postFilter == 3) {
          temp_post = temp_post.filter((post) => {
            return post.author == vm.auth.user.uid;
          });
        } else if(this.postFilter == 4) {
          temp_post = temp_post.filter((post) => {
            return post.likes.includes(vm.auth.user.uid);
          });
        }
        return temp_post.filter(function(post) {
          return post.title.toLowerCase().indexOf(vm.searchPost.toLowerCase()) >= 0;
        });
      },
    },
    methods: {
      save (date) {
        this.$refs.menu.save(date)
      },
      registerAccount() {
        var vm = this;
        vm.auth.message = '';
        vm.auth.hasErrors = false;
        vm.auth.success = false;
        vm.loader = true;
        auth.createUserWithEmailAndPassword(this.newUser.email, this.newUser.password).then(
          (user) => {
            vm.createAccount = false;
            vm.loader = false;
            vm.auth.message = "Account created";
            vm.auth.success = true;
          },
          (err) => {
            vm.auth.message = err.message;
            vm.auth.hasErrors = true;
            vm.loader = false;
          }
        )
      },
      signIn () {
        var vm = this;
        vm.auth.message = '';
        vm.auth.hasErrors = false;
        vm.auth.success = false;
        vm.loader = true;
        auth.signInWithEmailAndPassword(this.loginInformation.email, this.loginInformation.password).then(
          (user) => {
            vm.auth.user = auth.currentUser;
            vm.loader = false;
          },
          (err) => {
            vm.auth.message = err.message;
            vm.auth.hasErrors = true;
            vm.loader = false;
          }
        )
      },
      signOut () {
        auth.signOut().then(
          () => {
            this.profileInfo = {
              fullname: '',
              occupation: '',
              country: '',
              birthday: '',
              about: '',
              following: ''
            };
            this.userPictures = [];
            this.searchPost = '';
            this.showProfile = false;
            this.showPictures = false;
            this.targetProfile = '';
            this.showTargetProfile = false;
            this.lastKey = 4;
          }
        )
      },
      displayName () {
        return this.auth.user.displayName ?
          this.auth.user.displayName : this.auth.user.email;
      },
      showProfileScreen() {
        this.showProfile = true;
        this.showPictures = false;
        this.showTargetProfile = false;
      },
      profilePictureChange (event) {
        var vm = this;
        this.loader = true;
        const files = event.target.files;
        let filename = files[0].name;
        var storageRef = storage.ref('userProfile/' + this.auth.user.uid);
        let uploadFile = storageRef.put(files[0]).then((snapshot) => {
          snapshot.ref.getDownloadURL().then((url) => {
            this.profilePicture = url;
            this.loader = false;
            var ref = db.ref('users');
            this.profileInfo.picture = url;
            ref.child(this.auth.user.uid).set(this.profileInfo);
            vm.auth.user.updateProfile({
              photoURL: vm.profilePicture
            }).then(function () {
              vm.auth.user = vm.currentUser
            }, function(error) {

            });
          });
        });
      },
      updateProfile () {
        this.profileLoader = true;
        var vm = this;
        var ref = db.ref('users');
        ref.child(this.auth.user.uid).set(this.profileInfo);
        this.auth.user.updateProfile({
          displayName: vm.profileInfo.fullname
        }).then(function () {
          vm.auth.user = vm.currentUser
          vm.profileLoader = false;
          vm.showProfile = false;
        }, function(error) {
          vm.profileLoader = false;
        });
      },
      showGalleryScreen () {
        var vm = this;
        this.showProfile = false;
        this.$bindAsArray('userPictures', db.ref('/usersPictures/'+this.auth.user.uid));
        this.showPictures = true;
        this.showTargetProfile = false;
      },
      addPhotos (event) {
        var vm = this;
        this.pictureLoader = true;
        const files = event.target.files;
        var storageRef = storage.ref('userPictures/');
        var ref = db.ref('usersPictures');
        for(var i = 0; i < files.length; i++) {
          let uploadFile = storageRef.child("/" + this.auth.user.uid + "/" + files[i].name).put(files[i]).then((snapshot) => {
            snapshot.ref.getDownloadURL().then((url) => {
              let pic = {
                description: '',
                url: url
              }
              this.$firebaseRefs.userPictures.push(pic);
              this.pictureLoader = false;
            });
          });
        }
      },
      updatePhoto(photo) {
        if(photo.description.length <= 35) {
          const copy = {...photo};
          delete copy['.key'];
          this.$firebaseRefs.userPictures.child(photo['.key']).set(copy);
          this.photoDescription = -1;
        }
      },
      deletePhoto(key) {
        this.$firebaseRefs.userPictures.child(key).remove();
      },
      zoom(photo) {
        this.zoomedPhoto = photo;
        this.zoomPhotoDialog = true;
      },
      postPhoto(event) {
        const files = event.target.files;
        let filename = files[0].name;
        const fileReader = new FileReader();
        this.tempPhoto = files[0];
        fileReader.addEventListener('load', () => {
          this.postImagePreview = fileReader.result;
        });
        fileReader.readAsDataURL(files[0]);
      },
      sendPost() {
        this.postLoader = true;
        var vm = this;
        this.post.author = this.auth.user.uid;
        this.post.date = 0 - Date.now();
        if(this.postImagePreview != '') {
          var storageRef = storage.ref('userPictures/');
          var ref = db.ref('usersPictures');
          let uploadFile = storageRef.child("/" + this.auth.user.uid + "/" + this.tempPhoto.name).put(this.tempPhoto).then((snapshot) => {
            snapshot.ref.getDownloadURL().then((url) => {
              this.post.photo = url;
              this.$firebaseRefs.posts.push(this.post);
              this.postLoader = false;
              this.newPostDialog = false;
              this.tempPhoto = '';
              this.post = {
                title: '',
                subTitle: '',
                description: '',
                photo: '',
                author: '',
                date: '',
                likes: ''
              }
              this.postImagePreview = '';
            });
          });
        } else {
          this.$firebaseRefs.posts.push(this.post);
          this.postLoader = false;
          this.newPostDialog = false;
          this.post = {
            title: '',
            subTitle: '',
            description: '',
            photo: '',
            author: '',
            date: '',
            likes: ''
          }
        }
      },
      loadMore() {
        var vm = this;
        this.postLoader = true;
        this.shadowPosts = this.posts;
        this.lastKey += 4;
        this.$bindAsArray('posts', db.ref('posts').orderByChild("date").limitToFirst(vm.lastKey), null, (snapshot) => {
          if(this.posts.length < this.lastKey) {
            this.lastKey -= this.posts.length - this.lastKey;
          }
          this.postLoader = false;
          this.shadowPosts = null;
        });
      },
      unfollow(user) {
        var vm = this;
        this.profileInfo.following.splice(user, 1);
        if(this.profileInfo.following == '') {
          this.profileInfo.following = "";
        }
        db.ref('users/').child(vm.auth.user.uid).set(vm.profileInfo);
      }
    }
  }
</script>

<style lang="css">
.accountForm .checkbox label {
  font-size: 12px!important;
}
.photoZoom {
  width: auto;
}
</style>
